﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Xml.Linq;
using WpfApp1.Models;

namespace WpfApp1
{
    /// <summary>
    /// Логика взаимодействия для AddOrUpdateOrder.xaml
    /// </summary>
    public partial class AddOrUpdateOrder : Window
    {
        ApplicationContext db = new ApplicationContext();
        Orders order;
        public AddOrUpdateOrder()
        {
            InitializeComponent();
            LoadDatabase();
            order = new Orders();
        }

        public AddOrUpdateOrder(int id)
        {
            InitializeComponent();
            LoadDatabase();
            order = db.Orders.Local.FirstOrDefault(x => x.ID == id);
            tbDate.Text = order.Date.ToString();
            cbClient.SelectedValue = order.IdClient;
            cbUser.SelectedValue = order.IdUser;
            tbCost.Text = order.Cost.ToString();
            tbStatus.Text = order.StatusName;
        }

        void LoadDatabase()
        {
            // гарантируем, что база данных создана
            db.Database.EnsureCreated();
            // загружаем данные из БД
            db.Clients.Load();
            // загружаем данные из БД
            db.Users.Load();
            // загружаем данные из БД
            db.OrderStatus.Load();
            // загружаем данные из БД
            db.Orders.Load();

            cbClient.ItemsSource = db.Clients.Local.ToList();
            cbClient.SelectedValuePath = "ID";
            cbClient.DisplayMemberPath = "ClientName";

            cbUser.ItemsSource = db.Users.Local.ToList();
            cbUser.SelectedValuePath = "ID";
            cbUser.DisplayMemberPath = "UserName";
        }

        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                order.IdClient = Convert.ToInt32(cbClient.SelectedValue);
                order.IdUser = Convert.ToInt32(cbUser.SelectedValue);
                order.Date = tbDate.Text;
                order.Cost = Convert.ToDouble(tbCost.Text);
                OrderStatus status = db.OrderStatus.Local.FirstOrDefault(x => x.Name == tbStatus.Text);
                order.IdStatus = status.ID;

                if (order.ID == 0)
                {
                    db.Orders.Add(order);
                }
                db.SaveChanges();
                MessageBox.Show("Заказ добавлен");
                Close();
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
