﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using WpfApp1.Models;

namespace WpfApp1
{
    /// <summary>
    /// Логика взаимодействия для AddOrUpdateUser.xaml
    /// </summary>
    public partial class AddOrUpdateUser : Window
    {
        ApplicationContext db = new ApplicationContext();
        Users user;
        public AddOrUpdateUser()
        {
            InitializeComponent();
            LoadDatabase();
            user = new Users();
        }

        public AddOrUpdateUser(int id)
        {
            InitializeComponent();
            LoadDatabase();
            user = db.Users.Local.FirstOrDefault(x => x.ID == id);
            tbSurname.Text = user.Surname;
            tbName.Text = user.Name;
            tbPatronymic.Text = user.Patronymic;
            tbBirthday.Text = user.Birthday;
            tbSerial.Text = user.SerialPassport;
            tbNumber.Text = user.NumberPassport;
            tbWorkExperience.Text = user.WorkExperience.ToString();
            tbLogin.Text = user.Login;
            tbPassword.Text = user.Password;

            Role role = db.Role.Local.FirstOrDefault(x => x.ID == user.IdRole);
            tbRole.Text = role.NameRole;
            //switch (user.IdRole)
            //{
            //    case 1:
            //        tbRole.Text = "Администратор";
            //        break;
            //    case 2:
            //        tbRole.Text = "Пользователь";
            //        break;
            //    case 3:
            //        tbRole.Text = "Менеджер";
            //        break;
            //    case 4:
            //        tbRole.Text = "Сотрудник ПВЗ";
            //        break;
            //}
        }

        void LoadDatabase()
        {
            // гарантируем, что база данных создана
            db.Database.EnsureCreated();
            // загружаем данные из БД
            db.Users.Load();
            db.Role.Load();
        }

        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                user.Surname = tbSurname.Text;
                user.Name = tbName.Text;
                user.Patronymic = tbPatronymic.Text;
                user.Birthday = tbBirthday.Text;
                user.SerialPassport = tbSerial.Text;
                user.NumberPassport = tbNumber.Text;
                user.WorkExperience = Convert.ToInt32(tbWorkExperience.Text);
                user.Login = tbLogin.Text;
                user.Password = tbPassword.Text;

                Role role = db.Role.Local.FirstOrDefault(x => x.NameRole == tbRole.Text);
                user.IdRole = role.ID;
                //switch (tbRole.Text)
                //{
                //    case "Администратор":
                //        user.IdRole = 1;
                //        break;
                //    case "Пользователь":
                //        user.IdRole = 2;
                //        break;
                //    case "Менеджер":
                //        user.IdRole = 3;
                //        break;
                //    case "Сотрудник ПВЗ":
                //        user.IdRole = 4;
                //        break;
                //}
                if(user.ID == 0)
                {
                    db.Users.Add(user);
                }
                db.SaveChanges();
                MessageBox.Show("Пользователь добавлен");
                Close();
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
