﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WpfApp1.Models
{
    public class Orders
    {
        public int ID { get; set; }
        public string Date { get; set; }
        public int IdUser { get; set; }
        public int IdClient { get; set; }
        public double Cost { get; set; }
        public int IdStatus { get; set; }

        public string ClientName
        {
            get
            {
                ApplicationContext db = new ApplicationContext();
                // гарантируем, что база данных создана
                db.Database.EnsureCreated();
                // загружаем данные из БД
                db.Clients.Load();
                Clients client = db.Clients.Local.FirstOrDefault(x => x.ID == IdClient);
                return client.Surname + " " + client.Name[0] + ".";
            }
        }

        public string UserName
        {
            get
            {
                ApplicationContext db = new ApplicationContext();
                // гарантируем, что база данных создана
                db.Database.EnsureCreated();
                // загружаем данные из БД
                db.Users.Load();
                Users user = db.Users.Local.FirstOrDefault(x => x.ID == IdUser);
                return user.Surname + " " + user.Name[0] + ". " + user.Patronymic[0] + ".";
            }
        }

        public string StatusName
        {
            get
            {
                ApplicationContext db = new ApplicationContext();
                // гарантируем, что база данных создана
                db.Database.EnsureCreated();
                // загружаем данные из БД
                db.OrderStatus.Load();
                OrderStatus status = db.OrderStatus.Local.FirstOrDefault(x => x.ID == IdUser);
                return status.Name;
            }
        }
    }
}
