﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfApp1.Models;

namespace WpfApp1.Pages
{
    /// <summary>
    /// Логика взаимодействия для AuthorizationPage.xaml
    /// </summary>
    public partial class AuthorizationPage : Page
    {
        ApplicationContext db = new ApplicationContext();

        public AuthorizationPage()
        {
            InitializeComponent();
        }

        private void btnEnter_Click(object sender, RoutedEventArgs e)
        {
            // гарантируем, что база данных создана
            db.Database.EnsureCreated();
            // загружаем данные из БД
            db.Users.Load();
            // и устанавливаем данные в качестве контекста
            Users login = db.Users.Local.FirstOrDefault(x => x.Login == tbLogin.Text && x.Password == tbPassword.Text);
            if (login != null)
            {
                MessageBox.Show("Успешная авторизация!");
            }
            else
            {
                MessageBox.Show("Неверные данные для входа!");
            }
            FrameClass.frmMain.Navigate(new MainPage());
        }

        private void TextBlock_MouseDown(object sender, MouseButtonEventArgs e)
        {
            ForgotPassword forgot = new ForgotPassword();
            forgot.Show();
        }

        private void btnRegister_Click(object sender, RoutedEventArgs e)
        {
            AddOrUpdateUser add = new AddOrUpdateUser();
            add.Show();
        }
    }
}
