﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfApp1.Models;

namespace WpfApp1.Pages
{
    /// <summary>
    /// Логика взаимодействия для OrdersPage.xaml
    /// </summary>
    public partial class OrdersPage : Page
    {
        ApplicationContext db = new ApplicationContext();

        public OrdersPage()
        {
            InitializeComponent();            
            // гарантируем, что база данных создана
            db.Database.EnsureCreated();
            // загружаем данные из БД
            db.Orders.Load();
            // и устанавливаем данные в качестве контекста
            lstOrders.ItemsSource = db.Orders.Local.ToList();
        }

        private void btnEdit_Click(object sender, RoutedEventArgs e)
        {
            Button btn = sender as Button;
            int id = Convert.ToInt32(btn.Uid);
            Orders order = db.Orders.Local.FirstOrDefault(x => x.ID == id);
            AddOrUpdateOrder add = new AddOrUpdateOrder(id);
            add.Show();
        }

        private void btnDelete_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Button btn = sender as Button;
                int id = Convert.ToInt32(btn.Uid);
                Orders order = db.Orders.Local.FirstOrDefault(x => x.ID == id);
                db.Orders.Remove(order);
                db.SaveChanges();
                MessageBox.Show("Заказ удален!");
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            AddOrUpdateOrder add = new AddOrUpdateOrder();
            add.Show();
        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            FrameClass.frmMain.Navigate(new MainPage());
        }
    }
}
