﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfApp1.Models;

namespace WpfApp1.Pages
{
    /// <summary>
    /// Логика взаимодействия для UsersPage.xaml
    /// </summary>
    public partial class UsersPage : Page
    {
        ApplicationContext db = new ApplicationContext();

        public UsersPage()
        {
            InitializeComponent();
            // гарантируем, что база данных создана
            db.Database.EnsureCreated();
            // загружаем данные из БД
            db.Users.Load();
            // и устанавливаем данные в качестве контекста
            lstUsers.ItemsSource = db.Users.Local.ToList();
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            AddOrUpdateUser add = new AddOrUpdateUser();
            add.Show();
        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            FrameClass.frmMain.Navigate(new MainPage());
        }

        private void btnEdit_Click(object sender, RoutedEventArgs e)
        {
            Button btn = sender as Button;
            int id = Convert.ToInt32(btn.Uid);
            AddOrUpdateUser add = new AddOrUpdateUser(id);
            add.Show();
        }

        private void btnDelete_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Button btn = sender as Button;
                int id = Convert.ToInt32(btn.Uid);
                Users user = db.Users.Local.FirstOrDefault(x => x.ID == id);
                db.Users.Local.Remove(user);
                db.SaveChanges();
                MessageBox.Show("Пользователь удален!");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
